//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TClapan.h"
#include "Logging.h"
//
void TClapan::Init(int ClapanNo, TCoffeeModel *NewCoffeeModel)
{
    CoffeeModel = NewCoffeeModel;
    ClapanID = ClapanNo;
    y3 = 0;
}
// 
//  3   0 (  )
void TClapan::Go()
{
    if (y3 == 0) return;
    A3(0);
}
//  3   1 (   )
void TClapan::Open()
{
    A3(1);
}
//  3   2 (  )
void TClapan::Reset()
{
    A3(2);
}
//   3
//  "  "
bool TClapan::is_Ready()
{
    return (y3 == 0);
}
//  ""
bool TClapan::is_Opening()
{
    return (y3 == 1);
}
//  ""
bool TClapan::is_Opened()
{
    return (y3 == 2);
}
//  ""
bool TClapan::is_Closing()
{
    return (y3 == 3);
}
//  ""
bool TClapan::is_Error()
{
    return (y3 == 4);
}
// 
//x1 -  
bool TClapan::x1()
{
    bool result;
    AnsiString sResult;
    result = CoffeeModel->Clapan_isOpen(ClapanID);
    sResult = (result) ? "true" : "false";
    AppendToLog(">", "x1 - " + IntToStr(ClapanID+1) + "  -  " + sResult );
    return result;
}
//x2 -  
bool TClapan::x2()
{
    bool result;
    AnsiString sResult;
    result = CoffeeModel->Clapan_isClosed(ClapanID);
    sResult = (result) ? "true" : "false";
    AppendToLog(">", "x2 - " + IntToStr(ClapanID+1) + "  -  " + sResult );
    return result;
}
//   
bool TClapan::T1()
{
    bool result;
    AnsiString sResult;
    result = CoffeeModel->T1(ClapanID);
    sResult = (result) ? "true" : "false";
    AppendToLog(">", "T1 -     " + IntToStr(ClapanID+1) + "  -  " + sResult );
    return result;
}
//      
bool TClapan::T2()
{
    bool result;
    AnsiString sResult;
    result = CoffeeModel->T2(ClapanID);
    sResult = (result) ? "true" : "false";
    AppendToLog(">", "T2 -      " + IntToStr(ClapanID+1) + "  -  " + sResult );
    return result;
}
//   
bool TClapan::T3()
{
    bool result;
    AnsiString sResult;
    result = CoffeeModel->T3(ClapanID);
    sResult = (result) ? "true" : "false";
    AppendToLog(">", "T3 -     " + IntToStr(ClapanID+1) + "  -  " + sResult );
    return result;
}
	    // 
//  ""
void TClapan::z1()
{
    AppendToLog("*", "z1 -    " + IntToStr(ClapanID+1));
    CoffeeModel->Clapan_SetOpen(ClapanID, true);
}
//  ""
void TClapan::z2()
{
    AppendToLog("*", "z2 -    " + IntToStr(ClapanID+1));
    CoffeeModel->Clapan_SetOpen(ClapanID, false);
}
//  ""
void TClapan::z3()
{
    AppendToLog("*", "z3 -    " + IntToStr(ClapanID+1));
    CoffeeModel->Clapan_SetClose(ClapanID, true);//    return true;
}
//  ""
void TClapan::z4()
{
    AppendToLog("*", "z4 -    " + IntToStr(ClapanID+1));
    CoffeeModel->Clapan_SetClose(ClapanID, false);//    return true;
}
//  " "
void TClapan::z5()
{
    AppendToLog("*", "z5 -    " + IntToStr(ClapanID+1));
    CoffeeModel->SetDisplay2(" . " + IntToStr(ClapanID+1));
}
//  " "
void TClapan::z6()
{
    AppendToLog("*", "z2 -    " + IntToStr(ClapanID+1));
    CoffeeModel->SetDisplay2("");
}
//     
void TClapan::t1()
{
    AppendToLog("*", "t1 -      " + IntToStr(ClapanID+1));
    CoffeeModel->t1(ClapanID);
}
//     
void TClapan::t2()
{
    AppendToLog("*", "t2 -       " + IntToStr(ClapanID+1));
    CoffeeModel->t2(ClapanID);
}
//     
void TClapan::t3()
{
    AppendToLog("*", "t3 -      " + IntToStr(ClapanID+1));
    CoffeeModel->t3(ClapanID);
}
//     
void TClapan::tz1()
{
    AppendToLog("*", "tz1 -      " + IntToStr(ClapanID+1));
    CoffeeModel->tz1(ClapanID);
}
//        
void TClapan::tz2()
{
    AppendToLog("*", "tz2 -       " + IntToStr(ClapanID+1));
    CoffeeModel->tz2(ClapanID);
}
//     
void TClapan::tz3()
{
    AppendToLog("*", "tz3 -      " + IntToStr(ClapanID+1));
    CoffeeModel->tz3(ClapanID);
}
// 
void TClapan::A3(int e)
{
    int old_y3;
    AnsiString StateDescr;
    AnsiString NewStateDescr;
    AnsiString EventDescr;
    bool bx1;
    bool bx2;
    bool bT1;
    bool bT2;
    bool bT3;

    old_y3 = y3;
    //  
    switch (y3)
        {
        case 0:
            StateDescr = " (\"  \")";
        break;
        case 1:
            StateDescr = " (\"\")";
        break;
        case 2:
            StateDescr = " (\"\")";
        break;
        case 3:
            StateDescr = " (\"\")";
        break;
        case 4:
            StateDescr = " (\"\")";
        break;
        default:
            StateDescr = " !!!     !!!";
        break;
        }
    switch (e)
        {
        case 0:
            EventDescr = " (\"  \")";
        break;
        case 1:
            EventDescr = " (\"   \")";
        break;
        case 2:
            EventDescr = " (\"  \")";
        break;
        default:
            EventDescr = " !!!     !!!";
        break;
        }
    AppendToLog("{", "A3_"+ IntToStr(ClapanID+1)+":   " + IntToStr(y3) + StateDescr + "    e" + IntToStr(e) + EventDescr);

    bx1 = x1();
    bx2 = x2();
    bT1 = T1();
    bT2 = T2();
    bT3 = T3();

    switch (y3)
    {
        case 0:
            if (e == 1)       {z1(); t1();                      y3 = 1;};
        break;

        case 1:
            if (bT1 && bx1)   {tz1(); z2(); t2();               y3 = 2;}
            else
            if (bT1 &&!bx1)   {tz1(); z5(); z2();               y3 = 4;}
        break;

        case 2:
            if (bT2 )          {tz2(); z3(); t3();              y3 = 3;}
        break;

        case 3:
            if (bT3 && bx2)   {tz3(); z4();                     y3 = 0;}
            else
            if (bT3 &&!bx2)   {tz3(); z5(); z4();               y3 = 4;}
        break;

        case 4:
            if (e == 2)         {z6();                          y3 = 0;}
        break;
    }

    switch (y3)
        {
        case 4:
            z4(); z5();
        break;
        }

    //  
    switch (y3)
        {
        case 0:
            NewStateDescr = " (\"  \")";
        break;
        case 1:
            NewStateDescr = " (\"\")";
        break;
        case 2:
            NewStateDescr = " (\"\")";
        break;
        case 3:
            NewStateDescr = " (\"\")";
        break;
        case 4:
            NewStateDescr = " (\"\")";
        break;
        default:
            StateDescr = " !!!     !!!";
        break;
        }

    if (y3 != old_y3)
        {
        AppendToLog("T", "A3_"+ IntToStr(ClapanID+1)+":    " + IntToStr(old_y3) + StateDescr + "   " + IntToStr(y3) + NewStateDescr);
        }
    AppendToLog("}", "A3_"+ IntToStr(ClapanID+1)+":    e" + IntToStr(e) + EventDescr + "   " + IntToStr(y3) + NewStateDescr);

}

//---------------------------------------------------------------------------
#pragma package(smart_init)




