//---------------------------------------------------------------------------
#ifndef TCoffeeControlH
#define TCoffeeControlH
#include "TBoiler.h"
class TCoffeeControl
{
    public:
        //
        void Init(TCoffeeModel *NewCoffeeModel);
        // 
        //  0   0 ( )
        void Go();
        //  0   8 ( +)
        void PressPlus();
        //  0   9 ( -)
        void PressMinus();
        //  0   10 ( OK)
        void PressOk();
        //  0   11 ( CANCEL)
        void PressCancel();

        //  "  "
        bool is_Ready();
        //  " "
        bool is_ChooseTemp();
        //  "  "
        bool is_ChooseQty();
        //  " "
        bool is_Boiling();
        //  " "
        bool is_CoffeReady();
        //  " "
        bool is_InterrupedByUser();
        //  ""
        bool is_Error();

        //. public    
        TBoiler Boiler;
    private:
        // 
        int Temperature;
        //  ()
        int NeededCups;
        //   
        TCoffeeModel *CoffeeModel;

        // 
        //,    0 0 - "  ", 1 - " ", 2 - "  ", 3 - " ", 4 - " ", 5 - " ", 6 - ""
        int y0;

        // 
        //  
        void z18();
        //  
        void z19();
        //  
        void z20();
        //  
        void z21();
        // 
        void z22();
        // 
        void z23();
        // 
        void z24();
        //   
        void z25();
        //    
        void z26();
        //  
        void z27();
        //   
        void z28();
        //   
        void z29();
        //  
        void z30();

        // 
        void A0(int e);
};

//---------------------------------------------------------------------------
#endif
