//---------------------------------------------------------------------------
#ifndef uMainH
#define uMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include "TModelCoffee.h"
#include "TCoffeeControl.h"
//---------------------------------------------------------------------------
class TCoffeeBoiler : public TForm
{
__published:	// IDE-managed Components
    TTimer *Timer1;
    TTrackBar *TrackBarClapan1;
    TTrackBar *TrackBarClapan2;
    TCheckBox *CheckBoxHeater1;
    TCheckBox *CheckBoxHeater2;
    TCheckBox *CheckBoxClapan1Close;
    TCheckBox *CheckBoxClapan1Open;
    TCheckBox *CheckBoxClapan2Open;
    TCheckBox *CheckBoxClapan2Close;
    TCheckBox *CheckBoxNoWater;
    TGroupBox *GroupBoxDisplay;
    TLabel *LabelDisplay1;
    TLabel *LabelDisplay2;
    TSpeedButton *SpeedButtonPlus;
    TSpeedButton *SpeedButtonMinus;
    TSpeedButton *SpeedButtonOk;
    TSpeedButton *SpeedButtonCancel;
    TListBox *ListBoxLog;
    TCheckBox *CheckBoxGo;
    TSaveDialog *SaveDialog1;
    TGroupBox *GroupBox1;
    TGroupBox *GroupBox2;
    TLabel *LabelHeater1Temperature;
    TLabel *Label11;
    TGroupBox *GroupBox3;
    TGroupBox *GroupBox4;
    TLabel *LabelHeater2Temperature;
    TLabel *Label10;
    TLabel *Label13;
    TLabel *Label14;
    TLabel *Label15;
    TLabel *Label16;
    TLabel *Label17;
    TLabel *Label18;
    TLabel *Label19;
    TLabel *Label20;
    TGroupBox *GroupBox5;
    TLabel *Label21;
    TLabel *Label22;
    TGroupBox *GroupBox6;
    TLabel *Label3;
    TLabel *Label24;
    TBevel *Bevel1;
    TSpeedButton *SpeedButton1;
    TSpeedButton *SpeedButton2;
    TProgressBar *ProgressBar1;
    TProgressBar *ProgressBar2;
    TProgressBar *ProgressBar3;
    void __fastcall Timer1Timer(TObject *Sender);

    void __fastcall CheckBoxClapan1OpenClick(TObject *Sender);
    void __fastcall CheckBoxClapan1CloseClick(TObject *Sender);
    void __fastcall CheckBoxClapan2OpenClick(TObject *Sender);
    void __fastcall CheckBoxClapan2CloseClick(TObject *Sender);
    void __fastcall CheckBoxHeater1Click(TObject *Sender);
    void __fastcall CheckBoxHeater2Click(TObject *Sender);
    void __fastcall CheckBoxNoWaterClick(TObject *Sender);
    void __fastcall SpeedButtonPlusClick(TObject *Sender);
    void __fastcall SpeedButtonMinusClick(TObject *Sender);
    void __fastcall SpeedButtonOkClick(TObject *Sender);
    void __fastcall SpeedButtonCancelClick(TObject *Sender);
    void __fastcall SpeedButton1Click(TObject *Sender);
    void __fastcall SpeedButton2Click(TObject *Sender);
    
private:	// User declarations
    TCoffeeModel *CoffeeModel;
    TCoffeeControl CoffeeControl;
public:		// User declarations
    __fastcall TCoffeeBoiler(TComponent* Owner);
    void __fastcall Go();
    };
//---------------------------------------------------------------------------
extern PACKAGE TCoffeeBoiler *CoffeeBoiler;
//---------------------------------------------------------------------------
#endif
