//---------------------------------------------------------------------------
#ifndef TBoilerH
#define TBoilerH
#include "THeater.h"
#include "TClapan.h"
class TBoiler
{

    public:
        //
        void Init(double MaxTemp, double MinTemp, int CupsNeeded, TCoffeeModel *NewCoffeeModel);
        // 
        //  1   0 ( )
        void Go();
        //  1   6 (  )
        void StartBoiler();
        //  1   7 (  /  )
        void StopBoiler();

        //   1
        //  "  "
        bool is_Ready();
        //  " "
        bool is_WarmingUpHeaters();
        //  "    "
        bool is_ReadyForNextPortion();
        //  " "
        bool is_TakingWater();
        //  ""
        bool is_Boiling();
        //  " "
        bool is_FreeingSteam();
        //  "  "
        bool is_HeatingReadyCoffee();
        //  ""
        bool is_Error();
        //  " "
        bool is_NoWater();

        //2   2   public  ,      
        // 1 ()
        TClapan Clapan1;
        // 2 ()
        TClapan Clapan2;
        // 1 ()
        THeater Heater1;
        // 2 (    )
        THeater Heater2;
    private:
        //   
        TCoffeeModel *CoffeeModel;

        // - 
        int PortionsNeeded;
        //-  
        int PortionsBoiled;
        // -    
        bool BoiledAllPortions();
        //   
        void IncBoiledPortions();
        //   
        void ClearBoiledPortions();
        //,    1: 0 - "  ", 1 - " ", 2 - "    ",
        //3 - " ", 4 - "", 5 - " ", 6 - "  ", 7 - "", 8 - " "
        int y1;

        // 
        //x6 -  
        bool x6();
        //x7 -    
        bool x7();

        // 
        //   
        bool T5();
        //     
        void t5();
        //     
        void tz5();

        // 
        //  
        void z11_1();
        //  
        void z11_2();
        //  
        void z12_1();
        //  
        void z12_2();
        //  
        void z13_1();
        //  
        void z13_2();
        //   
        void z14();
        //   
        void z15();
        //   
        void z16();
        //   
        void z17();
        //  
        void z31();
        // 
        void z32();
        //   1
        void z33_1();
        //   2
        void z33_2();
        //   1
        void z34_1();
        //   2
        void z34_2();

        //  1
        void A1(int e);
};
//---------------------------------------------------------------------------
#endif
