//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "uMain.h"
#include <stdio.h>
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TCoffeeBoiler *CoffeeBoiler;
//---------------------------------------------------------------------------
__fastcall TCoffeeBoiler::TCoffeeBoiler(TComponent* Owner): TForm(Owner)
{
    CoffeeModel = new TCoffeeModel();
    CoffeeModel->Init();
    TrackBarClapan1->Max = CoffeeModel->Clapan_MAX[0];
    TrackBarClapan2->Max = CoffeeModel->Clapan_MAX[1];
    CoffeeControl.Init(CoffeeModel);
}
//---------------------------------------------------------------------------
void __fastcall TCoffeeBoiler::Go()
{
        CoffeeControl.Go();
        CoffeeModel->GO();
}
//---------------------------------------------------------------------------
void __fastcall TCoffeeBoiler::Timer1Timer(TObject *Sender)
{
        if ( CheckBoxGo->Checked) return;
        Go();
        TrackBarClapan1->Position = CoffeeModel->Clapan[0];
        TrackBarClapan2->Position = CoffeeModel->Clapan[1];

        CheckBoxHeater1->Checked = CoffeeModel->bHeater_On[0];
        CheckBoxHeater2->Checked = CoffeeModel->bHeater_On[1];

        CheckBoxClapan1Open->Checked = CoffeeModel->bClapan_OpenSignal[0];
        CheckBoxClapan1Close->Checked = CoffeeModel->bClapan_CloseSignal[0];
        CheckBoxClapan2Open->Checked = CoffeeModel->bClapan_OpenSignal[1];
        CheckBoxClapan2Close->Checked = CoffeeModel->bClapan_CloseSignal[1];
        LabelHeater1Temperature->Caption = IntToStr(CoffeeModel->Heater[0]);
        LabelHeater2Temperature->Caption = IntToStr(CoffeeModel->Heater[1]);

        ProgressBar1->Position = 0;
        ProgressBar2->Position = 0;
        ProgressBar3->Position = 0;
        if (CoffeeControl.Boiler.Clapan1.is_Ready())
                Label17->Caption = "  ";
        else
        if (CoffeeControl.Boiler.Clapan1.is_Opening())
                Label17->Caption = "";
        else
        if (CoffeeControl.Boiler.Clapan1.is_Opened())
                Label17->Caption = "";
        else
        if (CoffeeControl.Boiler.Clapan1.is_Closing())
                Label17->Caption = "";
        else
        if (CoffeeControl.Boiler.Clapan1.is_Error())
                Label17->Caption = "";
        //----
        if (CoffeeControl.Boiler.Clapan2.is_Ready())
                Label19->Caption = "  ";
        else
        if (CoffeeControl.Boiler.Clapan2.is_Opening())
                Label19->Caption = "";
        else
        if (CoffeeControl.Boiler.Clapan2.is_Opened())
                Label19->Caption = "";
        else
        if (CoffeeControl.Boiler.Clapan2.is_Closing())
                Label19->Caption = "";
        else
        if (CoffeeControl.Boiler.Clapan2.is_Error())
                Label19->Caption = "";
        //----
        if (CoffeeControl.Boiler.Heater1.is_Ready())
                Label18->Caption = "  ";
        else
        if (CoffeeControl.Boiler.Heater1.is_WarmingUp())
                Label18->Caption = "";
        else
        if (CoffeeControl.Boiler.Heater1.is_On())
                Label18->Caption = "";
        else
        if (CoffeeControl.Boiler.Heater1.is_Off())
                Label18->Caption = "";
        else
        if (CoffeeControl.Boiler.Heater1.is_Error())
                Label18->Caption = "";
        //----
        if (CoffeeControl.Boiler.Heater2.is_Ready())
                Label20->Caption = "  ";
        else
        if (CoffeeControl.Boiler.Heater2.is_WarmingUp())
                Label20->Caption = "";
        else
        if (CoffeeControl.Boiler.Heater2.is_On())
                Label20->Caption = "";
        else
        if (CoffeeControl.Boiler.Heater2.is_Off())
                Label20->Caption = "";
        else
        if (CoffeeControl.Boiler.Heater2.is_Error())
                Label20->Caption = "";

        //----
        if (CoffeeControl.Boiler.is_Ready())
                Label22->Caption = "  ";
        else
        if (CoffeeControl.Boiler.is_WarmingUpHeaters())
                Label22->Caption = "";
        else
        if (CoffeeControl.Boiler.is_ReadyForNextPortion())
                Label22->Caption = "  . ";
        else
        if (CoffeeControl.Boiler.is_TakingWater())
            {
                Label22->Caption = " ";
                ProgressBar1->Position = 1;
            }
        else
        if (CoffeeControl.Boiler.is_Boiling())
            {
                Label22->Caption = "";
                ProgressBar2->Position = 1;
            }
        else
        if (CoffeeControl.Boiler.is_FreeingSteam())
            {
                Label22->Caption = " ";
                ProgressBar3->Position = 1;
            }
        else
        if (CoffeeControl.Boiler.is_HeatingReadyCoffee())
                Label22->Caption = " ";
        else
        if (CoffeeControl.Boiler.is_Error())
                Label22->Caption = "";
        else
        if (CoffeeControl.Boiler.is_NoWater())
                Label22->Caption = " ";
        //--------
        if (CoffeeControl.is_Ready())
                Label24->Caption = "  ";
        else
        if (CoffeeControl.is_ChooseTemp())
                Label24->Caption = " ";
        else
        if (CoffeeControl.is_ChooseQty())
                Label24->Caption = " - ";
        else
        if (CoffeeControl.is_Boiling())
                Label24->Caption = " ";
        else
        if (CoffeeControl.is_CoffeReady())
                Label24->Caption = " ";
        else
        if (CoffeeControl.is_InterrupedByUser())
                Label24->Caption = " ";
        else
        if (CoffeeControl.is_Error())
                Label24->Caption = "";


        TrackBarClapan1->Repaint();
        TrackBarClapan2->Repaint();
        CheckBoxHeater1->Repaint();
        CheckBoxHeater2->Repaint();

        CheckBoxClapan1Open->Repaint();
        CheckBoxClapan1Close->Repaint();
        CheckBoxClapan2Open->Repaint();
        CheckBoxClapan2Close->Repaint();
        LabelHeater1Temperature->Repaint();
        LabelHeater2Temperature->Repaint();
        Label17->Repaint();
        Label18->Repaint();
        Label19->Repaint();
        Label20->Repaint();
        Label22->Repaint();
        Label24->Repaint();
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

void __fastcall TCoffeeBoiler::CheckBoxClapan1OpenClick(TObject *Sender)
{
        CoffeeModel->bClapan_OpenSignal[0] = CheckBoxClapan1Open->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TCoffeeBoiler::CheckBoxClapan1CloseClick(TObject *Sender)
{
        CoffeeModel->bClapan_CloseSignal[0]=CheckBoxClapan1Close->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TCoffeeBoiler::CheckBoxClapan2OpenClick(TObject *Sender)
{
        CoffeeModel->bClapan_OpenSignal[1] = CheckBoxClapan2Open->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TCoffeeBoiler::CheckBoxClapan2CloseClick(TObject *Sender)
{
        CoffeeModel->bClapan_CloseSignal[1] = CheckBoxClapan2Close->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TCoffeeBoiler::CheckBoxHeater1Click(TObject *Sender)
{
        CoffeeModel->bHeater_On[0] = CheckBoxHeater1->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TCoffeeBoiler::CheckBoxHeater2Click(TObject *Sender)
{
        CoffeeModel->bHeater_On[1] = CheckBoxHeater2->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TCoffeeBoiler::CheckBoxNoWaterClick(TObject *Sender)
{
        CoffeeModel->bNoWater = CheckBoxNoWater->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TCoffeeBoiler::SpeedButtonPlusClick(TObject *Sender)
{
    CoffeeControl.PressPlus();         // +
}
//---------------------------------------------------------------------------
void __fastcall TCoffeeBoiler::SpeedButtonMinusClick(TObject *Sender)
{
    CoffeeControl.PressMinus();        // -
}
//---------------------------------------------------------------------------
void __fastcall TCoffeeBoiler::SpeedButtonOkClick(TObject *Sender)
{
    CoffeeControl.PressOk();             // OK
}
//---------------------------------------------------------------------------
void __fastcall TCoffeeBoiler::SpeedButtonCancelClick(TObject *Sender)
{
    CoffeeControl.PressCancel();        //  CANCEL
}
//---------------------------------------------------------------------------
void __fastcall TCoffeeBoiler::SpeedButton1Click(TObject *Sender)
{
    bool bGo;
    SaveDialog1->FileName = "log1.log";
    bGo = CheckBoxGo->Checked;
    CheckBoxGo->Checked = false;
    if (SaveDialog1->Execute())
        {
        int i;
        FILE *f;
        if ((f = fopen(SaveDialog1->FileName.c_str(), "w")) == NULL) return;
        for (i = 0 ; i < ListBoxLog->Items->Count; i++)
            {
            fprintf(f, ListBoxLog->Items->Strings[i].c_str());
            fprintf(f, "\n");
            }
        fclose(f);
        };
    CheckBoxGo->Checked = bGo;
}
//---------------------------------------------------------------------------
void __fastcall TCoffeeBoiler::SpeedButton2Click(TObject *Sender)
{
    ListBoxLog->Clear();
}
//---------------------------------------------------------------------------


